﻿using Demo.domain.Models;
using Demo.Domain.UseCase;
using System;
using System.Text;

namespace Demo.UI
{
    public class UserConsoleUI
    {
        UserUseCase _userUseCase;

        public UserConsoleUI(UserUseCase userUseCase)
        {
            _userUseCase = userUseCase;
        }

        public void RemoveUserByGuid(Guid guidUser)
        {
            string output = _userUseCase.RemoveUserByGuid(guidUser) ? "Пользователь удален" : "Пользователь не удален";
            Console.WriteLine(output);
        }

        public void DisplayAllUsers()
        {
            StringBuilder userOutput = new StringBuilder();
            foreach (var user in _userUseCase.GetAllUsers())
            {
                userOutput.AppendLine($"{user.Guid}\t{user.FIO}\t{user.Group.Name}");
            }
            Console.WriteLine(userOutput);
        }

        public void FindUserByGuid(Guid userGuid)
        {
            var user = _userUseCase.FindUserByGuid(userGuid);
            if (user == null)
            {
                Console.WriteLine("Пользователь не найден.");
            }
            else
            {
                Console.WriteLine($"Найден пользователь: {user.Guid}, {user.FIO}, Группа: {user.Group?.Name}");
            }
        }

        public void UpdateUser(Guid userGuid, User updatedUser)
        {
            var result = _userUseCase.UpdateUser(userGuid, updatedUser);
            if (result != null)
            {
                Console.WriteLine("Пользователь обновлён.");
            }
            else
            {
                Console.WriteLine("Пользователь не найден.");
            }
        }
    }
}
